
OpenHelp proto :dword,:dword
OpenHelpExe proto :dword,:dword
OpenHelpHH proto :dword,:dword
OpenHelpHH2 proto :dword,:dword
PathCpy proto :dword,:dword

.code

PathCpy proc pDest:dword,pSrc:dword

	mov eax,pDest
	mov ecx,pSrc
@@:	mov dl,[ecx]
	inc ecx
	mov [eax],dl
	inc eax
	cmp dl,0
	jne @B
	dec eax
	.if byte ptr [eax-1]=="\"
		dec eax
		mov byte ptr [eax],0
	.endif
	sub eax,pDest
	ret

PathCpy endp

OpenHelp proc uses esi edi pkeyword:dword,phelpfile:dword
	
LOCAL pMem:dword
LOCAL quoted:dword
LOCAL pArgs:dword
	
	; Allocate a buffer for the completed path
	invoke GlobalAlloc,GMEM_FIXED,MAX_PATH*2
	
	; Copy phelpfile to the new buffer, replacing variables with their values
	; Also handle "quoted" files that have arguments after the quotes
	mov pMem,eax
	mov edi,eax
	mov esi,phelpfile
	mov ebx,lpData
	mov quoted,0
	mov pArgs,0
	.if byte ptr [esi]=='"'
		inc quoted
	.endif
	assume ebx:ptr ADDINDATA
ProcessLoop:	
	mov al,[esi]
	inc esi
	.if al=="$"
		mov al,[esi]
		inc esi
		.if al=="R"
			invoke PathCpy,edi,[ebx].lpLoadPath
		.elseif al=="D"
			invoke PathCpy,edi,[ebx].lpAddIn
		.elseif al=="A"
			invoke PathCpy,edi,[ebx].lpApp
		.elseif al=="H"
			invoke PathCpy,edi,[ebx].lpHlp
		.elseif al=="K"
			invoke PathCpy,edi,pkeyword
		.else ; To get $ in the output buffer, use $$
			jmp @f
		.endif
		add edi,eax
		jmp ProcessLoop
	.elseif quoted && al=='"' ; Accept quoted filenames with arguments following
		mov byte ptr [edi],0
		inc edi
	@@:	cmp byte ptr [esi]," "
		lea esi,[esi+1]
		je @B
		dec esi
		invoke StrLen,esi
		test eax,eax
		jz EndProcessLoop
		mov pArgs,esi
		dec quoted
		jmp ProcessLoop
	.endif
@@:	mov [edi],al
	inc edi
	cmp al,0
	jne ProcessLoop
EndProcessLoop:
	assume ebx:nothing
		
	; Check the file's type and open it in the appropriate way
	invoke lcase,pMem
	invoke PathIsURL,pMem
	.if eax
		mov eax,pMem
		.if (dword ptr [eax]=="h-sm") && (dword ptr [eax+4]==":ple") ; ms-help:
			invoke OpenHelpHH2,pMem,pkeyword ; HtmlHelp2 URL
		.else
			invoke ShellExecute,0,0,pMem,0,0,SW_SHOWDEFAULT ; Normal URL
		.endif
	.else
		invoke PathFindExtension,pMem
		mov edx,[eax]
		.if dl==0
			invoke MessageBox,0,pMem,CTEXT("Filename has no extension"),0
			jmp Done
		.endif
		.if edx=="plh." ;.hlp
			invoke WinHelp,0,pMem,HELP_KEY,pkeyword
		.elseif edx=="exe." ;.exe
			invoke OpenHelpExe,pMem,pArgs
		.elseif edx=="mhc." || edx=="loc." ; .chm or .col
			invoke OpenHelpHH,pMem,pkeyword
		.else
			mov eax,pMem
			mov eax,[eax]
			.if eax=="non)" || al==0 ; The .ini loading code set it to "(None)" if no entry exists in the ini
				Msg "No help file set."
			.else
				Msg "Unknown extension."
			.endif
			jmp Done
		.endif
	.endif
	
Done:
	invoke GlobalFree,pMem
	
	mov eax,TRUE
	ret

OpenHelp endp

OpenHelpExe proc pexefile:dword,pargs:dword

LOCAL psi:STARTUPINFO
LOCAL ppi:PROCESS_INFORMATION
	
	mov ecx,sizeof STARTUPINFO
	lea edi,psi
	xor eax,eax
	rep stosb
	
	mov psi.cb,sizeof STARTUPINFO
	
	invoke CreateProcess,pexefile,pargs,0,0,0,0,0,0,addr psi,addr ppi
	
	invoke CloseHandle,ppi.hProcess
	invoke CloseHandle,ppi.hThread
	ret

OpenHelpExe endp

OpenHelpHH proc pfilename:DWORD,pkeyword:DWORD

LOCAL link:HH_AKLINK

	; Initialize the struct
	mov link.cbStruct, sizeof HH_AKLINK
	mov link.fReserved, FALSE
	push pkeyword
	pop link.pszKeywords
	mov link.pszUrl, NULL
	mov link.pszMsgText, NULL
	mov link.pszMsgTitle, NULL
	mov link.pszWindow, NULL
	mov link.fIndexOnFail, FALSE

	.data?
		hHtmlOcx dd ?
		pHtmlHelpProc dd ?
		hHHwin dd ?
	.code
	
	; Load the ocx containing the HtmlHelpA API
	.if !hHtmlOcx || !pHtmlHelpProc
		invoke LoadLibrary,CTEXT("hhctrl.ocx")
		mov hHtmlOcx,eax
		invoke GetProcAddress,eax,CTEXT("HtmlHelpA")
		mov pHtmlHelpProc,eax
		.if !eax
			invoke FreeLibrary,hHtmlOcx
			mov hHtmlOcx,0
			Msg "Unable to load hhctrl.ocx"
			ret
		.endif
	.endif
	
	; Display the HH window if it doesn't exist
	invoke GetWindowThreadProcessId,hHHwin,NULL
	.if eax==0
		push NULL
		push HH_DISPLAY_TOPIC
		push pfilename
		push 0
		call [pHtmlHelpProc]
		mov hHHwin,eax
	.endif
	
	; Jump to the correct topic
	lea eax,link
	push eax
	push HH_KEYWORD_LOOKUP
	push pfilename
	push 0
	call [pHtmlHelpProc]

	ret

OpenHelpHH endp

OpenHelpHH2 proc pFilename:DWORD,pKeyword:DWORD
	LOCAL clbuffer[256]:BYTE
	LOCAL pathBuffer[MAX_PATH]:BYTE
		
	; Build Commandline
	
	mov eax,lpData
	invoke lstrcpy,ADDR pathBuffer,(ADDINDATA ptr [eax]).lpAddIn
	invoke PathAddBackslash,ADDR pathBuffer
	invoke lstrcpy,eax,CTEXT("\H2Viewer.exe ")

	invoke lstrcpy,ADDR clbuffer,CTEXT("/helpcol ")
	invoke lstrcat,ADDR clbuffer,pFilename
	invoke lstrcat,ADDR clbuffer,CTEXT(" /filterquery /index " ; /keyword ",'"',"K$") ; 22h,4bh,24h == "K$
	invoke lstrcat,ADDR clbuffer,pKeyword
	invoke lstrcat,ADDR clbuffer,CTEXT(' /XNav /appid RadASM')
	
	invoke OpenHelpExe,addr pathBuffer,addr clbuffer
	
	ret

OpenHelpHH2 endp
