;#########################################################################
;		Assembler directives

.486
.model flat,stdcall
option casemap:none

;#########################################################################
;		Include file

include ModelessAddin.inc

.code

;#########################################################################
;		Common AddIn Procedures

DllEntry proc hInst:HINSTANCE, reason:DWORD, reserved1:DWORD
	mov eax, hInst
	mov hInstance, eax
	mov eax, TRUE
	ret
DllEntry Endp

AddMenu proc
	LOCAL	nMnu:DWORD
	LOCAL	hMnu:DWORD

	mov		nMnu,6
	;Adjust topmost popup if maximized.
	mov		eax,[lpData]
	mov		eax,(ADDINDATA ptr [eax]).fMaximized
	.if eax
		inc		nMnu
	.endif
	;Get handle of menu
	mov		eax,[lpHandles]
	mov		eax,(ADDINHANDLES ptr [eax]).hMenu
	;Get handle of Tools popup
	invoke GetSubMenu,eax,nMnu		;Tools menu
	mov		hMnu,eax
	;Add our menuitem
	invoke AppendMenu,hMnu,MF_STRING,IDAddIn,addr szMenuItem
	ret

AddMenu endp

; Export this proc (it is autoexported if MakeDef is enabled with option 2)
InstallDll proc uses ebx hWin:DWORD, fOpt:DWORD
	mov	ebx,hWin

	;Get pointer to handles struct
	invoke SendMessage,ebx,AIM_GETHANDLES,0,0;	
	mov	lpHandles,eax

	;Get pointer to proc struct
	invoke SendMessage,ebx,AIM_GETPROCS,0,0
	mov	lpProc,eax

	;Get pointer to data struct
	invoke SendMessage,ebx,AIM_GETDATA,0,0	
	mov	lpData,eax
	; Allocate a new menu id
	invoke SendMessage,ebx,AIM_GETMENUID,0,0
	mov IDAddIn,eax
	invoke AddMenu
	; Messages to hook into
	mov	eax, RAM_COMMAND OR RAM_CLOSE OR RAM_MENUREBUILD
	; ECX and EDX must be null before we return
	xor ecx, ecx
	xor edx, edx
	ret 

InstallDll Endp

DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,uMsg
	.if eax==WM_INITDIALOG

	.elseif eax==WM_COMMAND
		mov		edx,wParam
		movzx	eax,dx
		shr		edx,16
		.if edx==BN_CLICKED
			.if eax==IDCANCEL
				invoke SendMessage,hWin,WM_CLOSE,NULL,NULL
			.endif
		.endif
	.elseif eax==WM_CLOSE
		invoke DestroyWindow,hWin
	.elseif eax==WM_ACTIVATE
		mov		eax,wParam
		.if ax==WA_INACTIVE
			;Deactivated
			mov		edx,lpHandles
			mov		eax,hGoTo
			mov		[edx].ADDINHANDLES.hGoTo,eax
		.else
			;Activated
			mov		edx,lpHandles
			mov		eax,[edx].ADDINHANDLES.hGoTo
			mov		hGoTo,eax
			mov		eax,hWin
			mov		[edx].ADDINHANDLES.hGoTo,eax
		.endif
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

DlgProc endp

; Export this proc (it is autoexported if MakeDef is enabled with option 2)
DllProc proc hWin:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	; This proc handles messages sent from RadASM to our dll
	; Return TRUE to prevent RadASM and other DLL's from

	mov	eax, uMsg
	.if eax == AIM_COMMAND
		mov eax,wParam
		movzx edx,ax
		shr eax, 16
		.IF edx == IDAddIn && eax == BN_CLICKED
			; Your addin has been selected
			invoke CreateDialogParam,hInstance,1000,NULL,addr DlgProc,NULL
		.ENDIF
	.elseif eax==AIM_CLOSE
		mov edx,lpHandles
		mov eax,[edx].ADDINHANDLES.hMenu
		invoke DeleteMenu,eax,IDAddIn,MF_BYCOMMAND
		mov IDAddIn,0
	.elseif eax==AIM_MENUREBUILD
		invoke AddMenu
	.endif
	mov eax,FALSE
	ret
DllProc Endp

;#########################################################################

End DllEntry
