;#########################################################################
;		Assembler directives

.486
.model flat,stdcall
option casemap:none

;#########################################################################
;		Include file

include ProcDump.inc

.code

;#########################################################################
;		Common AddIn Procedures

DllEntry proc hInst:HINSTANCE, reason:DWORD, reserved1:DWORD
	mov eax, hInst
	mov hInstance, eax
	mov eax, TRUE
	ret
DllEntry Endp

AddMenu proc

	.if IDAddIn
		mov		edx,4		;Project menu
		;Adjust topmost popup if maximized.
		mov		eax,lpData
		mov		eax,[eax].ADDINDATA.fMaximized
		.if eax
			inc		edx
		.endif
		;Get handle of menu
		mov		eax,lpHandles
		mov		eax,[eax].ADDINHANDLES.hMenu
		;Get handle of Project popup
		invoke GetSubMenu,eax,edx
		;Add our menuitem
		invoke AppendMenu,eax,MF_STRING,IDAddIn,addr szProcDump
	.endif
	ret

AddMenu endp

; Export this proc (it is autoexported if MakeDef is enabled with option 2)
InstallDll proc uses ebx hWin:DWORD, fOpt:DWORD
	mov	ebx,hWin

	;Get pointer to handles struct
	invoke SendMessage,ebx,AIM_GETHANDLES,0,0;	
	mov	lpHandles,eax

	;Get pointer to proc struct
	invoke SendMessage,ebx,AIM_GETPROCS,0,0
	mov	lpProc,eax

	;Get pointer to data struct
	invoke SendMessage,ebx,AIM_GETDATA,0,0	
	mov	lpData,eax

	; If Option (fOpt) = 0 then exit
	mov eax,fOpt
	test eax,eax
	je @F
		; Allocate a new menu id
		invoke SendMessage,ebx,AIM_GETMENUID,0,0
		mov IDAddIn,eax
		mov mytbbutton.idCommand,eax 
		invoke AddMenu
		mov ebx,[lpHandles] 
		mov ebx,(ADDINHANDLES ptr [ebx]).hToolBar 
		invoke SendMessage,ebx,TB_GETIMAGELIST,0,0 
		push eax 
		invoke LoadBitmap,hInstance,100 
		pop edx 
		push eax 
		invoke ImageList_AddMasked,edx,eax,808080h 
		mov   mytbbutton.iBitmap,eax 
		pop eax 
		invoke DeleteObject,eax 
		invoke SendMessage,ebx,TB_BUTTONSTRUCTSIZE,sizeof TBBUTTON,0 
		invoke SendMessage,ebx,TB_INSERTBUTTON,-1,offset mytbbutton 

		; Messages to hook into
		mov	eax, RAM_COMMAND OR RAM_CLOSE OR RAM_MENUREBUILD OR RAM_TBRTOOLTIP OR RAM_PROJECTOPENED OR RAM_PROJECTCLOSE

	@@:
	; ECX and EDX must be null before we return
	xor ecx, ecx
	xor edx, edx
	ret 

InstallDll Endp

GetOptions proc
	mov		eax,offset AddinOpt
	ret
GetOptions endp

ProcDump proc uses esi
	LOCAL	buffer[256]:BYTE

	mov		edx,lpData
	.if [edx].ADDINDATA.fProject
		;A project is loaded, dump the procs
		;Get pointer to word list
		mov		esi,[edx].ADDINDATA.lpWordList
		;Skip the words loaded from .api files
		add		esi,[edx].ADDINDATA.rpProjectWordList
		;Clear the output window
		invoke clrOutput
		;Loop trough the word list
		.while [esi].PROPERTIES.nSize
			;Check if it is a proc
			.if [esi].PROPERTIES.nType=='p'
				push	esi
				;Point to the proc name
				lea		esi,[esi+sizeof PROPERTIES]
				invoke lstrcpy,addr buffer,esi
				invoke lstrlen,esi
				;Point to the procs parameters
				lea		esi,[esi+eax+1]
				.if byte ptr [esi]
					invoke lstrlen,addr buffer
					mov		word ptr buffer[eax],','
					invoke lstrcat,addr buffer,esi
				.endif
				invoke lstrlen,esi
				;Point to the procs locals
				lea		esi,[esi+eax+1]
				.if byte ptr [esi]
					invoke lstrlen,addr buffer
					mov		dword ptr buffer[eax],':L '
					invoke lstrcat,addr buffer,esi
				.endif
				;Output the proc name
				invoke TextOutput,addr buffer
				pop		esi
			.endif
			;Move to next word
			mov		eax,[esi].PROPERTIES.nSize
			lea		esi,[esi+eax+sizeof PROPERTIES]
		.endw
	.endif
	ret

ProcDump endp

; Export this proc (it is autoexported if MakeDef is enabled with option 2)
DllProc proc hWin:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	; This proc handles messages sent from RadASM to our dll
	; Return TRUE to prevent RadASM and other DLL's from

	mov	eax, uMsg
	.if eax == AIM_COMMAND
		mov eax,wParam
		movzx edx,ax
		shr eax, 16
		.IF edx == IDAddIn && eax == BN_CLICKED
			; Your addin has been selected
			invoke ProcDump
		.ENDIF

	.ELSEIF eax==AIM_CLOSE
		;
	.ELSEIF eax==AIM_MENUREBUILD
		;
	.ELSEIF eax==AIM_TBRTOOLTIP
		;
	.ELSEIF eax==AIM_PROJECTCLOSE
		;
	.ELSEIF eax==AIM_PROJECTOPENED
		;
	.endif

	mov eax,FALSE
	ret
DllProc Endp

;#########################################################################

End DllEntry
